package eu.hsrw.tr.prog.vl.oop;

/**
 * Demo Vererbung
 * 
 * @author Thomas Richter
 *
 */
public class Student extends Person {
	// Klassenvariable, speichert die nächste zu vergebende Matrikelnummer.
	// Es existiert genau ein Exemplar der Variablen für ALLE Objekte des
	// Typs Student.
	// Das Schlüsselwort static kennzeichnet eine Klassenvariable
	private static int nextMatNr = 10000;
	
	// Matrikelnummer
	private int matnr;
	// Studienfach
	String fach;
	// Jahr des Studienbeginns
	int jsb;

	/**
	 * Student Konstruktor
	 * 
	 * @param vn
	 *            Vorname
	 * @param nn
	 *            Nachname
	 * @param t
	 *            Tag des Geburtsdatums
	 * @param m
	 *            Monat des Geburtsdatums
	 * @param j
	 *            Jahr des Geburtsdatums
	 * @param f
	 *            Studienfach
	 * @param jsb
	 *            Jahr des Studienbeginns
	 */
	public Student(String vn, String nn, int t, int m, int j, String f, int jsb) {

		// Konstruktor von Person aufrufen
		super(vn, nn, t, m, j);

		this.fach = f;
		this.jsb = jsb;

		// Matrikelnummer setzen
		this.matnr = Student.nextMatNr;
		// Zähler für Matrikelnummern erhöhen
		Student.nextMatNr++;
	}

	/**
	 * Copy Konstruktor
	 * 
	 * @param s
	 *            zu kopierendes Student Objekt
	 */
	public Student(Student s) {
		this.vorname = s.vorname;
		this.name = s.name;
		// Für Objekte muss wiederum deren Copy Konstruktor aufgerufen werden
		this.gebdat = new Datum(s.gebdat);
		this.fach = s.fach;
		this.jsb = s.jsb;
		this.matnr = s.matnr;
	}

	public int getMatnr() {
		return matnr;
	}

	public int jahrgang() {
		return this.jsb;
	}
}
